dist: bionic
os: linux
language: cpp

env:
  global:
    - secure: "dqiLqbzug/xs6F4Q9ei1pGpNf9Q6H3+iKN1W+P0TtODbCXPr/mLWdvHGVMIMqr7H7rBrIUPFPrfqd80nu3jQuQonjcHK/XyJJfmf5hUdhGAszSaixhWnGfVmn/VSV7/5+9DGAU3l9S6YZg4lvi12+cOrlblNgx8GeI5VdN/6HBSHkEqKNI56qn3Y+ugSdLeL1opmzlY58vRsCCmpBH8Ronn4tmSyi85/WZXfF43o9FGGJcygdh6QVWA1CDdNMeLTCt9ld+oToUIiFLiUrhfS1JpSvzysz2xsuEntxZaTMDYPyL4+O8Mj/scl6ejLLXzxTNa7AZOgySLBahf+F4b+yhL1deSVuu40MfxPW6XiM1jKy3KPH/GlYgM8CZQ3D1hQIq1CIUg8DgnTa06RUzevsR5DqDvz+EcPanFHE7dHGrPy9Rs/0y59dNHp3qWKjWMoSA06GerbF61XFOb4mcE29053kV8uxqIa5ZShZ/ndoLeVpQ4mZ+/XSkUybysVl0gWrKnnNNEPtqrdmKf+jlmKY0jyRPdwf425Ldn+wcbGw9ZEnkosYzqAhDBDX4OETAKLi8G0FEYECKKQcd1OX+HNvsOIyOAoLOj7H30F8UkPsjR3ysdIEmc6702ly06gDYjWmwQaCigL/1ktRKgf7ePB0HS+8fOa5SML7619kQrGrWA="
    - PREFIX="${HOME}/opt"
    - ASIO_VERSION="90f32660cd503494b3707840cfbd5434d8e9dabe"
    - LZ4_VERSION="1.8.3"
    - MBEDTLS_VERSION="2.7.5"
    - MBEDTLS_CFLAGS="-I${PREFIX}/include"
    - MBEDTLS_LIBS="-lmbedtls -lmbedx509 -lmbedcrypto"
    - OPENSSL_VERSION="1.0.2s"
    - OPENSSL_CFLAGS="-I${PREFIX}/include"
    - OPENSSL_LIBS="-lssl -lcrypto"
    - COVERITY_BRANCH="master"

matrix:
  include:
    - env: SSLLIB="openssl"
      os: osx
      osx_image: xcode10.2
      compiler: clang
    - env: SSLLIB="mbedtls"
      os: osx
      osx_image: xcode10.2
      compiler: clang
    - env: SSLLIB="openssl" RUN_COVERITY_SCAN="1"
      os: linux
      compiler: gcc
    - env: SSLLIB="openssl"
      os: linux
      compiler: clang
    - env: SSLLIB="mbedtls"
      os: linux
      compiler: gcc
    - env: SSLLIB="mbedtls"
      os: linux
      compiler: clang
    - env: MINGW=1 ARCH=x86_64
      os: linux
      addons:
        apt:
          packages:
            - mingw-w64
    - env: MINGW=1 ARCH=i686
      os: linux
      addons:
        apt:
          packages:
            - mingw-w64

addons:
  apt:
    packages:
      - libboost-all-dev
      - linux-libc-dev

cache:
  ccache: true
  directories:
  - download-cache
  - ${HOME}/opt

install:
  - .travis/build-deps.sh

script:
  - .travis/build-check.sh
